/*
 * @(#)pfail.h: $Revision: 1.12.61.2 $ $Date: 91/06/19 13:52:09 $
 * $Locker:  $
 * 
 */

/*
 * Defines needed by powerfail code.
 */
#define COPR_FP 	0x00000080	/* Floating point -- Coprocessor 0 */
#define SFU_MPY_DIVIDE	0x00008000	/* Multiply/Divide __ SFU 0 */
#define PFAIL_VECTOR	0x00000004	/* Absolute memory location 4!! */

/*
 *  Allowed values for pf_subsystem_flag.
 */
#define PF_DISABLED  0
#define PF_ENABLED   1
/*
 *  Allowed values for pf_state (in mpproc_info[].pf_info).
 */
#define PF_SAVESTATE            0
#define PF_PFR_SAVESTATE        1
#define PF_LOCAL_PD             3
#define PF_REMOTE_PD            4
#define PF_RECOVERY             6

/* (Mask) values for pf_stat_flag; they should only be set by the monarch.
 * All other processors can read the variable and check the masks.
 */
#define PF_STAT_CLEAR	0x00000000
#define PF_ACTIVE_MASK	0x00000001



#define	FAIL_MASK	0x02000000	/* FAIL bit in cio channel status reg */
#define	LOST_MASK	0x01000000	/* LOST bit in cio channel status reg */
#define IO_EXP_POLL_FRQ		(8 * hz)

#define SET_LOW_MEM(addr, val)  {*(void (**) () )addr = val;}
#define PF_ASSERT(assertion, message)           \
{                                               \
   extern void fcacheline(), panic();           \
   if (!assertion) {                            \
     SET_LOW_MEM(PFAIL_VECTOR, NULL);           \
     fcacheline(0, (caddr_t) PFAIL_VECTOR);     \
     panic(message);                            \
   }                                            \
}

